from typing import Any
from typing import List
from typing import Set
from typing import Tuple

from . import *


class LineartGpencilModifier(GpencilModifier):
    
    # Segments with an image distance smaller than this will be chained together
    chaining_image_threshold: float
    
    # Angles smaller than this will be treated as creases
    crease_threshold: float
    
    # Invert source vertex group values
    invert_source_vertex_group: bool
    
    # This modifier has baked data
    is_baked: bool
    
    # Maximum number of occlusions for the generated strokes
    level_end: int
    
    # Minimum number of occlusions for the generated strokes
    level_start: int
    
    # The strength value for the generate strokes
    opacity: float
    
    # Source collection that this modifier uses data from
    source_collection: Collection
    
    # Source object that this modifier uses data from
    source_object: Object
    
    # Line art stroke source type
    source_type: str = 'COLLECTION' # ['COLLECTION', 'OBJECT', 'SCENE']
    
    # Match the beginning of vertex group names from mesh objects, match all when left empty
    source_vertex_group: str
    
    # Angle in screen space below which a stroke is split in two
    split_angle: float
    
    # Grease Pencil layer assigned to the generated strokes
    target_layer: str
    
    # Grease Pencil material assigned to the generated strokes
    target_material: Material
    
    # The thickness for the generated strokes
    thickness: int
    
    # Allow lines generated by the near/far clipping plane to be shown
    use_clip_plane_boundaries: bool
    
    # Generate strokes from contours lines
    use_contour: bool
    
    # Generate strokes from creased edges
    use_crease: bool
    
    # Generate strokes from freestyle marked edges
    use_edge_mark: bool
    
    # Allow edges in the same location (i.e. from edge split) to show properly. May run slower
    use_edge_overlap: bool
    
    # Treat all lines as the same line type so they can be chained together
    use_fuzzy_all: bool
    
    # Treat intersection and contour lines as if they were the same type so they can be chained together
    use_fuzzy_intersections: bool
    
    # Generate strokes from intersections
    use_intersection: bool
    
    # Generate strokes from borders between materials
    use_material: bool
    
    # Generate strokes from a range of occlusion levels
    use_multiple_levels: bool
    
    # Support particle objects and face/vertex instances to show in line art
    use_object_instances: bool
    
    # Match output vertex group based on name
    use_output_vertex_group_match_by_name: bool
    
    # Remove doubles from the source geometry before generating stokes
    use_remove_doubles: bool
    
    # Use transparency mask from this material in line art
    use_transparency: bool
    
    use_transparency_mask: bool
    
    # Require matching all transparency masks instead of just one
    use_transparency_match: bool
    
    # Vertex group name for selected strokes
    vertex_group: str

    @classmethod
    def bl_rna_get_subclass(cls, *args, **kwargs) -> Struct:
        ...

    @classmethod
    def bl_rna_get_subclass_py(cls, *args, **kwargs) -> Any:
        ...